## libpdb-redo 2.0.3

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.16)

# set the project name
project(pdb-redo VERSION 2.0.3 LANGUAGES CXX C)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

enable_testing()

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(Dart)
include(FindPkgConfig)
include(GenerateExportHeader)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	# https://stackoverflow.com/questions/63902528/program-crashes-when-filesystempath-is-destroyed
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

# Build shared libraries by default (not my cup of tea, but hey)
option(BUILD_SHARED_LIBS "Build a shared library instead of a static one" OFF)

# We do not want to write an export file for all our symbols...
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

# Optionally build a version to be installed inside CCP4
option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4" OFF)
if(BUILD_FOR_CCP4)
	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
	else()
		list(APPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
		list(APPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
		set(CMAKE_INSTALL_PREFIX "$ENV{CCP4}")

		# This is the only option:
		if(WIN32)
			set(BUILD_SHARED_LIBS ON)
		endif()
	endif("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
endif()

# Check if CCP4 is available
if(EXISTS "$ENV{CCP4}")
	set(CCP4 $ENV{CCP4})
	set(CLIBD ${CCP4}/lib/data)
endif()
if(CCP4 AND NOT CLIBD)
	set(CLIBD ${CCP4}/lib/data)
endif()

if(MSVC)
    # make msvc standards compliant...
    add_compile_options(/permissive-)

	macro(get_WIN32_WINNT version)
		if (WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})

	# On Windows, do not install in the system location
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND NOT BUILD_FOR_CCP4)
		message(STATUS "The library and auxiliary files will be installed in $ENV{LOCALAPPDATA}/${PROJECT_NAME}")
		set(CMAKE_INSTALL_PREFIX "$ENV{LOCALAPPDATA}/${PROJECT_NAME}" CACHE PATH "..." FORCE)
	endif()

	# Find out the processor type for the target
	if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "AMD64")
		set(COFF_TYPE "x64")
	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i386")
		set(COFF_TYPE "x86")
	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "ARM64")
		set(COFF_TYPE "arm64")
	else()
		message(FATAL_ERROR "Unsupported or unknown processor type ${CMAKE_SYSTEM_PROCESSOR}")
	endif()	

	# for mrc, just in case
	list(APPEND CMAKE_PREFIX_PATH "$ENV{LOCALAPPDATA}/mrc")
endif()

if(UNIX AND NOT APPLE AND NOT BUILD_FOR_CCP4 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
	# On Linux, install in the $HOME/.local folder by default
	message(STATUS "The library and auxiliary files will be installed in $ENV{HOME}/.local")
	set(CMAKE_INSTALL_PREFIX "$ENV{HOME}/.local" CACHE PATH "..." FORCE)

	# libcifpp will be there as well, likely
	list(PREPEND CMAKE_PREFIX_PATH "$ENV{HOME}/.local")
endif()

# Optionally use mrc to create resources

if(WIN32 AND BUILD_SHARED_LIBS)
	message("Not using resources when building shared libraries for Windows")
else()
	find_program(MRC mrc)

	if(MRC)
		option(USE_RSRC "Use mrc to create resources" ON)
	else()
		message("Using resources not possible since mrc was not found")
	endif()

	if(USE_RSRC STREQUAL "ON")
		set(USE_RSRC 1)

		message("Using resources compiled with ${MRC}")
		add_compile_definitions(USE_RSRC)
	endif()
endif()

# Libraries
find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)
find_package(cifpp 3.0.0 REQUIRED)
find_package(zeep 5.1.7 REQUIRED)

pkg_check_modules(GSL gsl)
						   
find_library(NEWUOA_LIBRARY newuoa REQUIRED)
find_path(NEWUOA_INCLUDE_DIR newuoa.h)
check_include_file( "newuoa.h" HAVE_NEWUOA )

# Create a revision file, containing the current git version info
include(VersionString)
write_version_header("LibPDBREDO")

# Sources

set(project_sources 
	${PROJECT_SOURCE_DIR}/src/AtomShape.cpp
	${PROJECT_SOURCE_DIR}/src/ClipperWrapper.cpp
	${PROJECT_SOURCE_DIR}/src/DistanceMap.cpp
	${PROJECT_SOURCE_DIR}/src/MapMaker.cpp
	${PROJECT_SOURCE_DIR}/src/Ramachandran.cpp
	${PROJECT_SOURCE_DIR}/src/ResolutionCalculator.cpp
	${PROJECT_SOURCE_DIR}/src/SkipList.cpp
	${PROJECT_SOURCE_DIR}/src/Statistics.cpp
	${PROJECT_SOURCE_DIR}/src/Symmetry-2.cpp
)

set(project_headers 
	${PROJECT_SOURCE_DIR}/include/pdb-redo/AtomShape.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/ClipperWrapper.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/DistanceMap.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/MapMaker.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Ramachandran.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/ResolutionCalculator.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/SkipList.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Statistics.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Symmetry-2.hpp
)

if (GSL_FOUND)

	set(project_sources
		${project_sources}
		${PROJECT_SOURCE_DIR}/src/Compound.cpp
		${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
		${PROJECT_SOURCE_DIR}/src/Restraints.cpp)

	set(project_headers
		${project_headers}
		${PROJECT_SOURCE_DIR}/include/pdb-redo/Compound.hpp
		${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
		${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp)

endif()

add_library(pdb-redo ${project_sources} ${project_headers})
set_target_properties(pdb-redo PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_include_directories(pdb-redo PUBLIC ${CIFPP_INCLUDE_DIR} ${ZEEP_INCLUDE_DIR} ${Boost_INCLUDE_DIR})
target_link_libraries(pdb-redo PUBLIC cifpp::cifpp zeep::zeep ${CCP4_LIBRARIES} ${NEWUOA_LIBRARY} ${GSL_LIBRARIES})

target_include_directories(pdb-redo
	PUBLIC
	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

target_include_directories(pdb-redo PUBLIC
	${Boost_INCLUDE_DIR} ${NEWUOA_INCLUDE_DIR} ${ZEEP_INCLUDE_DIR} ${CIFPP_INCLUDE_DIR} ${CCP4_INCLUDE_DIRS}
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    target_link_options(pdb-redo PRIVATE -undefined dynamic_lookup)
endif (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")

set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR} )
set(LIBRARY_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR} )

generate_export_header(pdb-redo
	EXPORT_FILE_NAME pdb-redo/pdb-redo_export.hpp)

# Install rules

install(TARGETS pdb-redo
	EXPORT pdb-redoTargets
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT pdb-redoTargets
	FILE "pdb-redoTargets.cmake"
	NAMESPACE pdb-redo::
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
)

install(
	DIRECTORY include/pdb-redo
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
	COMPONENT Devel
)

install(
	FILES "${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redo_export.hpp"
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pdb-redo
	COMPONENT Devel
)

configure_package_config_file(Config.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfig.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
	PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR
)

install(FILES
		"${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfig.cmake"
		"${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfigVersion.cmake"
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
	COMPONENT Devel
)

set(pdb-redo_MAJOR_VERSION ${CMAKE_PROJECT_VERSION_MAJOR})
set_target_properties(pdb-redo PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${pdb-redo_MAJOR_VERSION}
	INTERFACE_pdb-redo_MAJOR_VERSION ${pdb-redo_MAJOR_VERSION})

set_property(TARGET pdb-redo APPEND PROPERTY
  COMPATIBLE_INTERFACE_STRING pdb-redo_MAJOR_VERSION
)

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfigVersion.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion
)

# pkgconfig support

set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir      ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
set(includedir  ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libpdb-redo.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in @ONLY)
file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc
	INPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# Unit tests

option(PDB_REDO_BUILD_TESTS "Build test exectuables" OFF)

if(PDB_REDO_BUILD_TESTS)

	if(USE_RSRC)
		add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/pdb_redo_test_rsrc.obj
			COMMAND ${MRC} -o ${CMAKE_CURRENT_BINARY_DIR}/pdb_redo_test_rsrc.obj ${CIFPP_SHARE_DIR}/mmcif_pdbx_v50.dic ${COFF_SPEC}
		)
		set(PDB_REDO_TEST_RESOURCE ${CMAKE_CURRENT_BINARY_DIR}/pdb_redo_test_rsrc.obj)
	endif()

	list(APPEND PDB_REDO_tests unit rsr)

	foreach(PDB_REDO_TEST IN LISTS PDB_REDO_tests)
		set(PDB_REDO_TEST "${PDB_REDO_TEST}-test")
		set(PDB_REDO_TEST_SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/test/${PDB_REDO_TEST}.cpp")

		add_executable(${PDB_REDO_TEST} ${PDB_REDO_TEST_SOURCE} ${PDB_REDO_TEST_RESOURCE})

		target_include_directories(${PDB_REDO_TEST} PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/include
			${CMAKE_CURRENT_BINARY_DIR}  # for config.h
		)

		target_link_libraries(${PDB_REDO_TEST} PRIVATE pdb-redo)
	
		if(MSVC)
			# Specify unwind semantics so that MSVC knowns how to handle exceptions
			target_compile_options(${PDB_REDO_TEST} PRIVATE /EHsc)
		endif()

		add_custom_target("run-${PDB_REDO_TEST}" DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch ${PDB_REDO_TEST})

		add_custom_command(
			OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch
			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${CMAKE_SOURCE_DIR}/test)

		add_test(NAME ${PDB_REDO_TEST}
			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${CMAKE_SOURCE_DIR}/test)

	endforeach()
endif()

=== examples/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.16)

# set the project name
project(pdb-redo-example VERSION 3.0.0 LANGUAGES CXX C)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(MSVC)
    # make msvc standards compliant...
    add_compile_options(/permissive-)

	macro(get_WIN32_WINNT version)
		if (WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})
endif()

# Libraries
find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)
find_package(pdb-redo 2.0.0 REQUIRED)

add_executable(pdb-redo-example example.cpp)
target_link_libraries(pdb-redo-example pdb-redo::pdb-redo)

enable_testing()

add_test(NAME pdb-redo-example
	COMMAND $<TARGET_FILE:pdb-redo-example>
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

## libpdb-redo 1.0.2

=== debian/changelog ===
libpdb-redo (1.0.2-2) unstable; urgency=medium

  * Added version numbers to the build-dependencies libzeep and libcifpp
  * Increased tolerance for unit-test to work around i386 failure

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 04 Jan 2021 13:00:54 +0100

libpdb-redo (1.0.2-1) unstable; urgency=medium

  * New upstream version (includes patch from 1.0.1-2)
  * Fixes pkg-config problem for cross-building
    Closes: #978057

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 04 Jan 2021 08:35:24 +0100

libpdb-redo (1.0.1-2) unstable; urgency=medium

  * Fix for missing check in bondmap

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 15 Dec 2020 21:02:30 +0100

libpdb-redo (1.0.1-1) unstable; urgency=medium

  * Updated again with the right upstream code, but this time with a new tag

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 14 Dec 2020 16:01:18 +0100

libpdb-redo (1.0.0-2) unstable; urgency=medium

  * Updated with the right upstream code

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 14 Dec 2020 14:09:01 +0100

libpdb-redo (1.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #976727)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 07 Dec 2020 10:50:19 +0100

=== debian/control ===
Source: libpdb-redo
Section: libs
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Build-Depends:
 debhelper-compat (= 13),
 libcifpp-dev (>= 1.0.1),
 autoconf-archive,
 libnewuoa-dev,
 pkg-config,
 libgsl-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libzeep-dev (>= 5.0.2),
 libclipper-dev,
 libccp4-dev (>= 6.5.1-5)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libpdb-redo
Vcs-Git: https://salsa.debian.org/med-team/libpdb-redo.git
Homepage: https://github.com/PDB-REDO/libpdb-redo
Rules-Requires-Root: no

Package: libpdb-redo-dev
Section: libdevel
Architecture: any
Depends:
 libpdb-redo1 (= ${binary:Version}),
 ${misc:Depends},
Description: Development files for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This specific package contains all files needed to develop new
 software using libpdb-redo.

Package: libpdb-redo1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libcifpp1,
 libnewuoa0
Description: Library file for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This package contains the shared library for libpdb-redo.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared --disable-static

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make test
endif

## libpdb-redo 2.0.3

=== debian/changelog ===
libpdb-redo (2.0.3-1build1) jammy; urgency=medium

  * No-change rebuild against libcifpp2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 04 Feb 2022 22:34:58 +0000

libpdb-redo (2.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 03 Feb 2022 11:29:02 +0100

libpdb-redo (2.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 03 Feb 2022 10:07:32 +0100

libpdb-redo (2.0.1-3) unstable; urgency=medium

  * Transition, Closes: #1004798

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 02 Feb 2022 08:58:20 +0100

libpdb-redo (2.0.1-2) experimental; urgency=medium

  * Set correct dependency for libcifpp

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 19 Jan 2022 13:06:22 +0100

libpdb-redo (2.0.1-1) experimental; urgency=medium

  [ Andrius Merkys ]
  * Team upload.

  [ Maarten L. Hekkelman ]
  * New upstream release

 -- Andrius Merkys <merkys@debian.org>  Tue, 09 Nov 2021 02:35:39 -0500

libpdb-redo (1.0.2-3) unstable; urgency=medium

  * Update dependency to libzeep, libcifpp

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 02 Nov 2021 07:35:14 +0100

=== debian/control ===
Source: libpdb-redo
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Build-Depends:
 debhelper-compat (= 13),
 libcifpp-dev (>= 2.0.4),
 cmake,
 libnewuoa-dev,
 pkg-config,
 libgsl-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libzeep-dev (>= 5.1.7),
 libclipper-dev,
 zlib1g-dev,
 libbz2-dev,
 libccp4-dev (>= 6.5.1-5)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libpdb-redo
Vcs-Git: https://salsa.debian.org/med-team/libpdb-redo.git
Homepage: https://github.com/PDB-REDO/libpdb-redo
Rules-Requires-Root: no

Package: libpdb-redo-dev
Section: libdevel
Architecture: any
Depends:
 libpdb-redo2 (= ${binary:Version}),
 ${misc:Depends},
Description: Development files for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This specific package contains all files needed to develop new
 software using libpdb-redo.

Package: libpdb-redo2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libcifpp2,
 libnewuoa0
Description: Library file for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This package contains the shared library for libpdb-redo.

## libpdb-redo 3.0.5

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.16)

# set the project name
project(pdb-redo VERSION 3.0.5 LANGUAGES CXX C)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# Unit tests
option(ENABLE_TESTING "Build test exectuables" OFF)

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(CheckCXXSourceCompiles)
include(GenerateExportHeader)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

# Building shared libraries?
option(BUILD_SHARED_LIBS "Build a shared library instead of a static one" OFF)

# We do not want to write an export file for all our symbols...
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

# Optionally build a version to be installed inside CCP4
option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4" OFF)


# Unit tests
option(ENABLE_TESTING "Build test exectuables" OFF)

if(BUILD_FOR_CCP4)
	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
	else()
		list(APPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
		list(APPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
		set(CMAKE_INSTALL_PREFIX "$ENV{CCP4}")

		# This is the only option:
		if(WIN32)
			set(BUILD_SHARED_LIBS ON)
		endif()
	endif("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
endif()


# Check if CCP4 is available
if(EXISTS "$ENV{CCP4}")
	set(CCP4 $ENV{CCP4})
	set(CLIBD ${CCP4}/lib/data)
endif()

if(CCP4 AND NOT CLIBD)
	set(CLIBD ${CCP4}/lib/data)
endif()

if(MSVC)
	# make msvc standards compliant...
	add_compile_options(/permissive-)

	macro(get_WIN32_WINNT version)
		if(WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})
endif()

# Libraries
find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)

if(NOT PDB_REDO_META)
	find_package(newuoa REQUIRED)
	find_package(cifpp 5.0.4 REQUIRED)
endif()

find_package(GSL REQUIRED)

# Create a revision file, containing the current git version info
include(VersionString)
write_version_header("${PROJECT_SOURCE_DIR}/src" "LibPDBREDO")

# Sources
set(project_sources
	${PROJECT_SOURCE_DIR}/src/AtomShape.cpp
	${PROJECT_SOURCE_DIR}/src/BondMap.cpp
	${PROJECT_SOURCE_DIR}/src/ClipperWrapper.cpp
	${PROJECT_SOURCE_DIR}/src/Compound.cpp
	${PROJECT_SOURCE_DIR}/src/DistanceMap.cpp
	${PROJECT_SOURCE_DIR}/src/MapMaker.cpp
	${PROJECT_SOURCE_DIR}/src/Ramachandran.cpp
	${PROJECT_SOURCE_DIR}/src/ResolutionCalculator.cpp
	${PROJECT_SOURCE_DIR}/src/SkipList.cpp
	${PROJECT_SOURCE_DIR}/src/Statistics.cpp
	${PROJECT_SOURCE_DIR}/src/Symmetry-2.cpp
	${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
	${PROJECT_SOURCE_DIR}/src/Restraints.cpp
)

set(project_headers
	${PROJECT_SOURCE_DIR}/include/pdb-redo/AtomShape.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/BondMap.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/ClipperWrapper.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Compound.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/DistanceMap.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/MapMaker.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Ramachandran.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/ResolutionCalculator.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/SkipList.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Statistics.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Symmetry-2.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp
)

add_library(pdb-redo ${project_sources} ${project_headers})
add_library(pdb-redo::pdb-redo ALIAS pdb-redo)
set_target_properties(pdb-redo PROPERTIES POSITION_INDEPENDENT_CODE ON)
generate_export_header(pdb-redo EXPORT_FILE_NAME pdb-redo/exports.hpp)

target_include_directories(pdb-redo
	PUBLIC
	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include;${PROJECT_BINARY_DIR}>"
	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
	${CCP4_INCLUDE_DIRS})
target_link_libraries(pdb-redo PUBLIC cifpp::cifpp newuoa::newuoa ${CCP4_LIBRARIES} ${GSL_LIBRARIES})

if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
	target_link_options(pdb-redo PRIVATE -undefined dynamic_lookup)
endif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")

set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(LIBRARY_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})

# Install rules
install(TARGETS pdb-redo
	EXPORT pdb-redoTargets
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT pdb-redoTargets
	FILE "pdb-redoTargets.cmake"
	NAMESPACE pdb-redo::
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
)

install(
	DIRECTORY include/pdb-redo
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
	COMPONENT Devel
)

install(
	FILES ${PROJECT_BINARY_DIR}/pdb-redo/exports.hpp
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pdb-redo/
	COMPONENT Devel
)

configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/pdb-redoConfig.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfig.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
	PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR
)

install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfig.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfigVersion.cmake"
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
	COMPONENT Devel
)

set(pdb-redo_MAJOR_VERSION ${CMAKE_PROJECT_VERSION_MAJOR})
set_target_properties(pdb-redo PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${pdb-redo_MAJOR_VERSION}
	INTERFACE_pdb-redo_MAJOR_VERSION ${pdb-redo_MAJOR_VERSION})

set_property(TARGET pdb-redo APPEND PROPERTY
	COMPATIBLE_INTERFACE_STRING pdb-redo_MAJOR_VERSION
)

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfigVersion.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)

# pkgconfig support
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
set(includedir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})

configure_file(${PROJECT_SOURCE_DIR}/cmake/libpdb-redo.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in @ONLY)
file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc
	INPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

if(ENABLE_TESTING)
	enable_testing()

	list(APPEND PDB_REDO_tests pdb-redo-unit rsr)

	foreach(PDB_REDO_TEST IN LISTS PDB_REDO_tests)
		set(PDB_REDO_TEST "${PDB_REDO_TEST}-test")
		set(PDB_REDO_TEST_SOURCE "${PROJECT_SOURCE_DIR}/test/${PDB_REDO_TEST}.cpp")

		add_executable(${PDB_REDO_TEST} ${PDB_REDO_TEST_SOURCE})
		target_link_libraries(${PDB_REDO_TEST} PRIVATE pdb-redo)

		if(MSVC)
			# Specify unwind semantics so that MSVC knowns how to handle exceptions
			target_compile_options(${PDB_REDO_TEST} PRIVATE /EHsc)
		endif()

		add_custom_target("run-${PDB_REDO_TEST}" DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch ${PDB_REDO_TEST})

		add_custom_command(
			OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch
			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${PROJECT_SOURCE_DIR}/test)

		add_test(NAME ${PDB_REDO_TEST}
			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${PROJECT_SOURCE_DIR}/test)
	endforeach()
endif()

# Tarball generation
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
set(CPACK_SOURCE_TGZ ON)
set(CPACK_SOURCE_TBZ2 OFF)
set(CPACK_SOURCE_TXZ OFF)
set(CPACK_SOURCE_TZ OFF)
set(CPACK_SOURCE_IGNORE_FILES "/data/components.cif;/build;/.vscode;/.git;/regex/doc;/regex/example;/regex/meta;/regex/performance;/regex/test")
set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_FILE_NAME})
include(CPack)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # set the project name
-project(pdb-redo-example VERSION 3.0.0 LANGUAGES CXX C)
+project(pdb-redo-example VERSION 3.0.4 LANGUAGES CXX C)
 
 set(CXX_EXTENSIONS OFF)
 set(CMAKE_CXX_STANDARD 17)
@@ -51,7 +51,7 @@
 
 # Libraries
 find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)
-find_package(pdb-redo 2.0.0 REQUIRED)
+find_package(pdb-redo 3.0.4 REQUIRED)
 
 add_executable(pdb-redo-example example.cpp)
 target_link_libraries(pdb-redo-example pdb-redo::pdb-redo)
@@ -60,4 +60,4 @@
 
 add_test(NAME pdb-redo-example
 	COMMAND $<TARGET_FILE:pdb-redo-example>
-	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
+	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

=== debian/changelog ===
libpdb-redo (3.0.5-2) unstable; urgency=medium

  * Fix libcifpp dependency.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 03 Feb 2023 09:22:45 +0100

libpdb-redo (3.0.5-1) unstable; urgency=medium

  * New upstream.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Feb 2023 10:34:38 +0100

libpdb-redo (3.0.4-3) unstable; urgency=medium

  * Fix dependency on newuoa to 0.1.2-1.
  * Closes: #1025778

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sat, 07 Jan 2023 14:47:28 +0100

libpdb-redo (3.0.4-2) unstable; urgency=medium

  * Into unstable.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 30 Dec 2022 09:12:03 +0100

libpdb-redo (3.0.4-1) experimental; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 23 Nov 2022 14:08:29 +0100

=== debian/control ===
Source: libpdb-redo
Section: libs
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Build-Depends:
 debhelper-compat (= 13),
 libcifpp-dev (>= 5.0.7),
 cmake,
 libnewuoa-dev (>= 0.1.2),
 pkg-config,
 libgsl-dev,
 libboost-dev,
 libboost-regex-dev,
 libclipper-dev,
 zlib1g-dev,
 libccp4-dev (>= 6.5.1-5)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libpdb-redo
Vcs-Git: https://salsa.debian.org/med-team/libpdb-redo.git
Homepage: https://github.com/PDB-REDO/libpdb-redo
Rules-Requires-Root: no

Package: libpdb-redo-dev
Section: libdevel
Architecture: any
Depends:
 libpdb-redo3 (= ${binary:Version}),
 libboost-regex-dev,
 libnewuoa-dev,
 libclipper-dev,
 zlib1g-dev,
 libgsl-dev,
 libcifpp-dev,
 ${misc:Depends},
Description: Development files for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This specific package contains all files needed to develop new
 software using libpdb-redo.

Package: libpdb-redo3
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libcifpp5,
 libnewuoa0
Description: Library file for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This package contains the shared library for libpdb-redo.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DPDB_REDO_BUILD_TESTS=ON

## libpdb-redo 3.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,12 +25,9 @@
 cmake_minimum_required(VERSION 3.16)
 
 # set the project name
-project(pdb-redo VERSION 3.0.5 LANGUAGES CXX C)
+project(libpdb-redo VERSION 3.1.5 LANGUAGES CXX C)
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
-
-# Unit tests
-option(ENABLE_TESTING "Build test exectuables" OFF)
 
 include(GNUInstallDirs)
 include(CheckFunctionExists)
@@ -39,9 +36,10 @@
 include(CMakePackageConfigHelpers)
 include(CheckCXXSourceCompiles)
 include(GenerateExportHeader)
+include(CTest)
 
 set(CXX_EXTENSIONS OFF)
-set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
@@ -59,9 +57,8 @@
 # Optionally build a version to be installed inside CCP4
 option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4" OFF)
 
-
-# Unit tests
-option(ENABLE_TESTING "Build test exectuables" OFF)
+# Optionally leave out the minimizer
+option(BUILD_MINIMIZER "Build the minimizer code" ON)
 
 if(BUILD_FOR_CCP4)
 	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
@@ -78,7 +75,6 @@
 	endif("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
 endif()
 
-
 # Check if CCP4 is available
 if(EXISTS "$ENV{CCP4}")
 	set(CCP4 $ENV{CCP4})
@@ -92,6 +88,7 @@
 if(MSVC)
 	# make msvc standards compliant...
 	add_compile_options(/permissive-)
+	add_link_options(/NODEFAULTLIB:library)
 
 	macro(get_WIN32_WINNT version)
 		if(WIN32 AND CMAKE_SYSTEM_VERSION)
@@ -108,21 +105,24 @@
 endif()
 
 # Libraries
+find_package(Eigen3 REQUIRED)
 find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)
+
+if(BUILD_MINIMIZER)
+	find_package(GSL REQUIRED)
+endif()
 
 if(NOT PDB_REDO_META)
 	find_package(newuoa REQUIRED)
-	find_package(cifpp 5.0.4 REQUIRED)
-endif()
-
-find_package(GSL REQUIRED)
+	find_package(cifpp 7.0.6 REQUIRED)
+endif()
 
 # Create a revision file, containing the current git version info
 include(VersionString)
-write_version_header("${PROJECT_SOURCE_DIR}/src" "LibPDBREDO")
+write_version_header("${PROJECT_SOURCE_DIR}/src" LIB_NAME "LibPDBREDO")
 
 # Sources
-set(project_sources
+list(APPEND project_sources
 	${PROJECT_SOURCE_DIR}/src/AtomShape.cpp
 	${PROJECT_SOURCE_DIR}/src/BondMap.cpp
 	${PROJECT_SOURCE_DIR}/src/ClipperWrapper.cpp
@@ -133,12 +133,11 @@
 	${PROJECT_SOURCE_DIR}/src/ResolutionCalculator.cpp
 	${PROJECT_SOURCE_DIR}/src/SkipList.cpp
 	${PROJECT_SOURCE_DIR}/src/Statistics.cpp
-	${PROJECT_SOURCE_DIR}/src/Symmetry-2.cpp
-	${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
-	${PROJECT_SOURCE_DIR}/src/Restraints.cpp
-)
-
-set(project_headers
+	${PROJECT_SOURCE_DIR}/src/TLS.cpp
+	${PROJECT_SOURCE_DIR}/src/Version.cpp
+)
+
+list(APPEND project_headers
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/AtomShape.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/BondMap.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/ClipperWrapper.hpp
@@ -149,22 +148,38 @@
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/ResolutionCalculator.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/SkipList.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/Statistics.hpp
-	${PROJECT_SOURCE_DIR}/include/pdb-redo/Symmetry-2.hpp
-	${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
-	${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp
-)
+	${PROJECT_SOURCE_DIR}/include/pdb-redo/TLS.hpp
+	${PROJECT_SOURCE_DIR}/include/pdb-redo/Version.hpp
+)
+
+if(BUILD_MINIMIZER)
+	list(APPEND project_sources
+		${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
+		${PROJECT_SOURCE_DIR}/src/Restraints.cpp
+	)
+
+	list(APPEND project_headers
+		${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
+		${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp
+	)
+endif()
 
 add_library(pdb-redo ${project_sources} ${project_headers})
 add_library(pdb-redo::pdb-redo ALIAS pdb-redo)
 set_target_properties(pdb-redo PROPERTIES POSITION_INDEPENDENT_CODE ON)
-generate_export_header(pdb-redo EXPORT_FILE_NAME pdb-redo/exports.hpp)
+generate_export_header(pdb-redo EXPORT_FILE_NAME ${PROJECT_SOURCE_DIR}/include/pdb-redo/exports.hpp)
 
 target_include_directories(pdb-redo
 	PUBLIC
-	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include;${PROJECT_BINARY_DIR}>"
+	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
 	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
 	${CCP4_INCLUDE_DIRS})
-target_link_libraries(pdb-redo PUBLIC cifpp::cifpp newuoa::newuoa ${CCP4_LIBRARIES} ${GSL_LIBRARIES})
+target_link_libraries(pdb-redo PUBLIC cifpp::cifpp newuoa::newuoa ${CCP4_LIBRARIES})
+target_include_directories(pdb-redo PRIVATE ${EIGEN3_INCLUDE_DIR})
+
+if(BUILD_MINIMIZER)
+	target_link_libraries(pdb-redo PUBLIC GSL::gsl)
+endif()
 
 if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
 	target_link_options(pdb-redo PRIVATE -undefined dynamic_lookup)
@@ -193,11 +208,9 @@
 	COMPONENT Devel
 )
 
-install(
-	FILES ${PROJECT_BINARY_DIR}/pdb-redo/exports.hpp
-	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pdb-redo/
-	COMPONENT Devel
-)
+if(BUILD_MINIMIZER)
+	set(FIND_DEPENDENCY_GSL "find_dependency(GSL REQUIRED)")
+endif()
 
 configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/pdb-redoConfig.cmake.in
 	${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfig.cmake
@@ -212,11 +225,10 @@
 	COMPONENT Devel
 )
 
-set(pdb-redo_MAJOR_VERSION ${CMAKE_PROJECT_VERSION_MAJOR})
 set_target_properties(pdb-redo PROPERTIES
 	VERSION ${PROJECT_VERSION}
-	SOVERSION ${pdb-redo_MAJOR_VERSION}
-	INTERFACE_pdb-redo_MAJOR_VERSION ${pdb-redo_MAJOR_VERSION})
+	SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
+	INTERFACE_pdb-redo_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
 
 set_property(TARGET pdb-redo APPEND PROPERTY
 	COMPATIBLE_INTERFACE_STRING pdb-redo_MAJOR_VERSION
@@ -240,10 +252,13 @@
 	INPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
-if(ENABLE_TESTING)
-	enable_testing()
-
-	list(APPEND PDB_REDO_tests pdb-redo-unit rsr)
+if(BUILD_TESTING AND NOT MSVC)
+	add_subdirectory(examples)
+
+	list(APPEND PDB_REDO_tests pdb-redo-unit)
+	if(BUILD_MINIMIZER)
+		list(APPEND PDB_REDO_tests rsr)
+	endif()
 
 	foreach(PDB_REDO_TEST IN LISTS PDB_REDO_tests)
 		set(PDB_REDO_TEST "${PDB_REDO_TEST}-test")

=== debian/changelog ===
libpdb-redo (3.1.5-5) unstable; urgency=medium

  * Remove incorrect dependency, Closes: #1086519

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 31 Oct 2024 23:10:45 +0100

libpdb-redo (3.1.5-4) unstable; urgency=medium

  * Closes: #1046388, #1085426

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 29 Oct 2024 07:33:57 +0100

libpdb-redo (3.1.5-2) unstable; urgency=medium

  * Create a new upload.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 25 Oct 2024 14:36:33 +0200

libpdb-redo (3.1.5-1) unstable; urgency=medium

  * New upstream 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 25 Oct 2024 14:11:00 +0200

libpdb-redo (3.1.3-2) unstable; urgency=medium

  * Update libcifpp dependency.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 25 Oct 2024 11:36:18 +0200

libpdb-redo (3.1.3-1) unstable; urgency=medium

  * New upstream.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 18 Oct 2024 09:41:32 +0200

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,14 @@
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends:
  debhelper-compat (= 13),
- libcifpp-dev (>= 5.0.7),
+ libcifpp-dev (>= 7),
  cmake,
  libnewuoa-dev (>= 0.1.2),
- pkg-config,
+ pkgconf,
  libgsl-dev,
  libboost-dev,
  libboost-regex-dev,
+ libeigen3-dev,
  libclipper-dev,
  zlib1g-dev,
  libccp4-dev (>= 6.5.1-5)
@@ -44,9 +45,7 @@
 Architecture: any
 Depends:
  ${misc:Depends},
- ${shlibs:Depends},
- libcifpp5,
- libnewuoa0
+ ${shlibs:Depends}
 Description: Library file for libpdb-redo
  This library contains shared code for the various programs
  in the project PDB-REDO.

## libpdb-redo 3.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # set the project name
-project(libpdb-redo VERSION 3.1.5 LANGUAGES CXX C)
+project(libpdb-redo VERSION 3.2.1 LANGUAGES CXX C)
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
 
@@ -112,9 +112,12 @@
 	find_package(GSL REQUIRED)
 endif()
 
-if(NOT PDB_REDO_META)
+if(NOT (newuoa_FOUND OR TARGET newuoa))
 	find_package(newuoa REQUIRED)
-	find_package(cifpp 7.0.6 REQUIRED)
+endif()
+
+if(NOT (cifpp_FOUND OR TARGET cifpp))
+	find_package(cifpp 7.0.9 REQUIRED)
 endif()
 
 # Create a revision file, containing the current git version info
@@ -252,35 +255,8 @@
 	INPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
-if(BUILD_TESTING AND NOT MSVC)
-	add_subdirectory(examples)
-
-	list(APPEND PDB_REDO_tests pdb-redo-unit)
-	if(BUILD_MINIMIZER)
-		list(APPEND PDB_REDO_tests rsr)
-	endif()
-
-	foreach(PDB_REDO_TEST IN LISTS PDB_REDO_tests)
-		set(PDB_REDO_TEST "${PDB_REDO_TEST}-test")
-		set(PDB_REDO_TEST_SOURCE "${PROJECT_SOURCE_DIR}/test/${PDB_REDO_TEST}.cpp")
-
-		add_executable(${PDB_REDO_TEST} ${PDB_REDO_TEST_SOURCE})
-		target_link_libraries(${PDB_REDO_TEST} PRIVATE pdb-redo)
-
-		if(MSVC)
-			# Specify unwind semantics so that MSVC knowns how to handle exceptions
-			target_compile_options(${PDB_REDO_TEST} PRIVATE /EHsc)
-		endif()
-
-		add_custom_target("run-${PDB_REDO_TEST}" DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch ${PDB_REDO_TEST})
-
-		add_custom_command(
-			OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch
-			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${PROJECT_SOURCE_DIR}/test)
-
-		add_test(NAME ${PDB_REDO_TEST}
-			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${PROJECT_SOURCE_DIR}/test)
-	endforeach()
+if(BUILD_TESTING AND NOT MSVC AND PROJECT_IS_TOP_LEVEL)
+	add_subdirectory(test)
 endif()
 
 # Tarball generation

=== debian/changelog ===
libpdb-redo (3.2.1-1) unstable; urgency=medium

  * New upstream version 3.2.1

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 28 Jan 2025 16:20:25 +0100

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  debhelper-compat (= 13),
  libcifpp-dev (>= 7),
  cmake,
+ libcatch2-dev,
  libnewuoa-dev (>= 0.1.2),
  pkgconf,
  libgsl-dev,
